#include "EyeLightShader.hxx"
#include "Primitive.hxx"

EyeLightShader::EyeLightShader(Scene* scene,
			       const Vec3f& color)
  : Shader(scene),
    m_color(color)
{
}

EyeLightShader::~EyeLightShader()
{
}

EyeLightShader::EyeLightShader()
  : Shader(0),
    m_color(Vec3f())
{
}

Vec3f
EyeLightShader::Shade(Ray& ray)
{
  Vec3f N = ray.hit()->GetNormal(ray);
  float cos_phi = fabs(ray.direction().dot(N));
  
  return m_color * cos_phi;
}
