#include "SpotLight.hxx"

SpotLight::SpotLight(Scene* scene,
		     const Vec3f& pos,
		     const Vec3f& dir,
		     const Vec3f& intensity,
		     float alpha_min,
		     float alpha_max)
  : Light(scene),
    m_pos(pos),
    m_dir(dir),
    m_intensity(intensity),
    m_alpha_min(alpha_min),
    m_alpha_max(alpha_max)
{
}

SpotLight::~SpotLight()
{
}

SpotLight::SpotLight()
  : Light(0),
    m_pos(Vec3f()),
    m_dir(Vec3f()),
    m_intensity(Vec3f()),
    m_alpha_min(0.0f),
    m_alpha_max(0.0f)
{
}

bool
SpotLight::Illuminate(Ray& ray, Vec3f& intensity)
{
  return false;
}

const Vec3f&
SpotLight::position() const
{
  return m_pos;
}

const Vec3f&
SpotLight::direction() const
{
  return m_dir;
}
