#ifndef SPOTLIGHT_HXX
#define SPOTLIGHT_HXX

#include "Light.hxx"

class SpotLight : public Light
{
public:
  SpotLight(Scene* scene, const Vec3f& pos, const Vec3f& dir, const Vec3f& intensity, float alpha_min, float alpha_max);
  virtual ~SpotLight();

  virtual bool Illuminate(Ray& ray, Vec3f& intensity);
  
  const Vec3f& position() const;
  const Vec3f& direction() const;
 
private:
  SpotLight();

  // position and direction
  Vec3f m_pos, m_dir;
  // emission (red, green, blue)
  Vec3f m_intensity;
  // opening angles
  float m_alpha_min, m_alpha_max;
};
#endif
